import random
import os
import pdb
import copy
import msvcrt
import time
#Создаем класс снаряда
class Patrons:
	# создаем def где активность ложь heading= 0 
    def __init__(self, active=False,  x_pos=-1, y_pos=-1, heading=0):
        self.active = active
        self.x_pos = x_pos
        self.y_pos = y_pos
        self.heading = heading

    def set_all_values(self, active=False, x_pos=-1, y_pos=-1, heading=0):
        self.active = active
        self.x_pos = x_pos
        self.y_pos = y_pos
        self.heading = heading
        #создаем координатную ось
    def set_coordinates(self, x_val, y_val):
        self.x_pos = x_val
        self.y_pos = y_val

    def set_x(self, x_val):
        self.x_pos = x_val

    def set_y(self, y_val):
        self.y_pos = y_val

    def set_heading(self, heading):
        self.heading = heading

    def get_heading(self):
        return self.heading

    def get_x(self):
        return self.x_pos

    def get_y(self):
        return self.y_pos

    def set_active(self, active):
        self.active = active

    def is_active(self):
        return self.active

    def disable(self):
        self.active = False
        self.x_pos = -1
        self.y_pos = -1
        self.heading = 0


# создаем новый класс где храниться Patrons
class VehiclePatrons(Patrons):
    def __init__(self, active=False, x_pos=-1, y_pos=-1, firing=False, fire_order=-1, heading=0):
        super().__init__(active, x_pos, y_pos, heading)
        self.firing = firing
        self.fire_order = fire_order

    def set_all_values(self, active=False, x_pos=-1, y_pos=-1, firing=False, fire_order=-1, heading=0):
        super().set_all_values(active, x_pos, y_pos, heading)
        self.firing = firing
        self.fire_order = fire_order

    def set_fire_order(self, fire_order):
        self.fire_order = fire_order

    def get_fire_order(self):
        return self.fire_order

    def get_coordinates_array(self):
        coordinates = [self.x_pos, self.y_pos]
        return coordinates

    def shift_down(self):
        self.x_pos += 1

    def toggle_fired(self):
        self.firing = not self.firing

    def reload(self):
        self.firing = False

    def disable(self):
        super().disable()
        self.firing = False
        self.fire_order = -1
class GameVariables:
    def __init__(self, frame_count=0, score=0, lives=3, int_direction=1):
            # Временные данные
            self.frame_count = frame_count
            self.start = time.perf_counter()

            self.bool_frame_sound = False
            self.bool_end_sound = False

            # главные игровые пременные
            self.score = score
            self.lives = lives
            self.int_direction = int_direction

            # создание сетки
            self.game_grid = [['*' for i in range(50)] for j in range(15)]

            # берем и присваеваем данные из VehiclePatrons
            self.player_Patrons = VehiclePatrons(True, 14, 24, False, 0, -1)

            # Создаем поле для врагов
            self.list_of_enemies = [VehiclePatrons() for i in range(30)]
            self.set_enemies_to_default()

            # Массив возможных объектов-снарядов с их местоположением и заголовками
            self.list_of_projectiles = [Patrons(False, -1, -1, 0) for i in range(16)]

            self.selection = [">PLAY<", " QUIT "]
            self.confirm_selection = False
            self.in_menu = False

    # Устанавливаем позиции врагов
    def set_enemies_to_default(self):
        position = [0, 2]
        fire_order = 1
        for enemy in self.list_of_enemies:
            enemy.set_coordinates(position[0], position[1])
            if position[1] > 43:
                position[0] += 1
                position[1] = -1
            position[1] += 3
            if enemy.get_x() == 1:
                enemy.set_fire_order(fire_order)
                enemy.set_heading(1)
                fire_order += 1
            enemy.set_active(True)

    def enable_fire(self, Patrons):
        for enemy in self.list_of_enemies:
            if enemy.get_coordinates_array() == [Patrons.get_x() - 1, Patrons.get_y()]:
                enemy.set_fire_order(Patrons.get_fire_order())
                enemy.set_heading(Patrons.get_heading())
    def update_firing_order(self):
        random.seed()
        for enemy in self.list_of_enemies:
            if enemy.get_fire_order() != -1 and random.randint(1, 15) == enemy.get_fire_order():
                self.fire(enemy)

    def fire(self, Patrons):
        if not Patrons.firing:
            if not self.bool_frame_sound:
                self.bool_frame_sound = True
            Patrons.toggle_fired()
            self.list_of_projectiles[Patrons.fire_order].set_all_values(True, Patrons.x_pos + Patrons.heading,
                                                                       Patrons.y_pos, Patrons.heading)

    # Устанавливает in_menu переменной значение true, чтобы войти в меню
    def enter_menu(self):
        self.in_menu = True

    # Устанавливает in_menu переменной и подтверждения выбора переменных в значение false, чтобы выйти из меню
    def exit_menu(self):
        self.confirm_selection = False
        self.in_menu = False

    # Возвращает true, если игрок находится в меню
    def is_in_menu(self):
        return self.in_menu

    # Проверка подтверждения выбора игрока (нажатие клавиши Enter) на экранах меню
    def is_selection_confirmed(self):
        return self.confirm_selection

    # Возвращает true, если игрок выбрал воспроизведение или воспроизведение, false, если игрок хочет выйти из игры
    def is_replay_selected(self):
        if self.selection == [">PLAY<", " QUIT "]:
            return True
        else:
            return False

    # Проверка ввода с клавиатуры для движения игрока и стрельбы
    def get_keypress(self):
        keypress = msvcrt.kbhit()
        if keypress:
            pos = self.player_Patrons.get_y()
            key = ord(msvcrt.getch())
            if key == 32:
                self.fire(self.player_Patrons)
            if key == 13:
                if self.in_menu:
                    self.confirm_selection = True
            if key == 77:
                if self.in_menu:
                    self.selection = [" PLAY ", ">QUIT<"]
                if pos < 49:
                    self.player_Patrons.set_y(pos + 1)
            if key == 75:
                if self.in_menu:
                    self.selection = [">PLAY<", " QUIT "]
                if pos > 0:
                    self.player_Patrons.set_y(pos - 1)

    # Сбрасывает позицию игрока и снижает количество жизней
    def kill_player(self):
        self.lives -= 1
        self.player_Patrons.set_all_values(True, 14, 24, False, 0, -1)

    @staticmethod
    # Проверка столкновений между объектами
    def has_collision(Patrons_one, Patrons_two):
        if Patrons_one.get_x() == Patrons_two.get_x() and Patrons_one.get_y() == Patrons_two.get_y():
            return True
        return False

    # Перемещает снаряды
    def move_projectiles(self):
        if self.frame_count % 3 == 0:
            int_count = 0
            for projectile_Patrons in self.list_of_projectiles:
                pos = projectile_Patrons.get_x()
                # Если снаряд находится в пределах досягаемости, переместите его в соответствующем направлении
                if 0 < pos < 14:
                    projectile_Patrons.set_x(pos + projectile_Patrons.get_heading())
                # Если он выходит за пределы, разрешите сущности снова стрелять
                else:
                    # Проверьте наличие подходящего объекта для перезагрузки
                    if int_count == 0:
                        self.player_Patrons.reload()
                    else:
                        for enemy in self.list_of_enemies:
                            if enemy.get_fire_order() == int_count:
                                enemy.reload()
                    projectile_Patrons.disable()
                int_count += 1

    # Перемещает врагов
    def move_enemies(self):
        if self.frame_count % 15 == 0:
            list_of_future_positions = copy.deepcopy(self.list_of_enemies)
            bool_shift_down = False

            # Переместите всех врагов в текущем направлении
            for temp_Patrons in list_of_future_positions:
                if not temp_Patrons.is_active():
                    continue
                pos = temp_Patrons.get_y() + self.int_direction
                # Если какой-либо объект находится за любой границей, отмените направленное движение и сдвиньтесь вниз
                if pos >= 50 or pos < 0:
                    self.int_direction *= -1
                    bool_shift_down = True
                    break
                else:
                    temp_Patrons.set_y(pos)

            # Если враг ударился о стену, мы отменяем движение влево/вправо и сдвигаем все объекты вниз
            if bool_shift_down:
                for enemy_Patrons in self.list_of_enemies:
                    if not enemy_Patrons.is_active():
                        continue
                    enemy_Patrons.shift_down()
                    if enemy_Patrons.get_x() == 14:
                        self.lives -= 1
                        enemy_Patrons.disable()
            else:
                self.list_of_enemies = list_of_future_positions

            self.update_firing_order()
            if self.lives < 1:
                self.lives = 0

    #проверки столкновения снарядов для игрока и врагов
    def check_collisions(self):
        # Проверьте наличие столкновения противника со снарядом игрока
        for enemy_Patrons in self.list_of_enemies:
            if enemy_Patrons.is_active():
                if self.has_collision(enemy_Patrons, self.list_of_projectiles[0]):
                    self.player_Patrons.reload()
                    self.list_of_projectiles[0].disable()
                    self.enable_fire(enemy_Patrons)
                    enemy_Patrons.disable()
                    self.score += 10

        # Проверка на столкновение снаряда с игроком
        int_count = 0
        for projectile_Patrons in self.list_of_projectiles:
            if self.has_collision(self.player_Patrons, projectile_Patrons):
                for enemy in self.list_of_enemies:
                    if enemy.get_fire_order() == int_count:
                        enemy.reload()
                        self.list_of_projectiles[int_count].disable()
                        self.kill_player()
            int_count += 1

    # Обновляет позиции игрока и врагов на игровом поле
    def update_board(self):
        # Очищаем окно
        del self.game_grid
        self.game_grid = [[' ' for i in range(50)] for j in range(15)]

        # обновление игровой сетки с позицией игрока
        self.game_grid[self.player_Patrons.get_x()][self.player_Patrons.get_y()] = '^'

        # обновите игровую сетку со всеми позициями противника
        for enemy_Patrons in self.list_of_enemies:
            if enemy_Patrons.is_active():
                self.game_grid[enemy_Patrons.get_x()][enemy_Patrons.get_y()] = 'W'

        # обновите игровую сетку со всеми позициями снарядов
        for projectile_Patrons in self.list_of_projectiles:
            if projectile_Patrons.is_active():
                self.game_grid[projectile_Patrons.get_x()][projectile_Patrons.get_y()] = '|'

    # Печать игровой сетки, жизней и очков
    def print_board(self):
        # Создаем оформление
        board_string = ""
        for row in self.game_grid:
            board_string += "█"
            for entry in row:
                board_string += entry
            board_string += "█\n"

        # печать игровых данных
        out = [board_string, "Счет : " + str(self.score), "Space INVADERS\n <>- клавиши управления\n пробел-стрельба", "Жизни : " + str(self.lives)]
        os.system('cls')
        print("{}{:<12}{:^26}{:^20}".format(*out))

    # печать стартового меню
    def print_game_start(self):
        self.confirm_selection = False
        board_string = ""
        count = 0
        for row in self.game_grid:
            if count == 6:
                board_string += "█{:^50}█\n".format("Space INVADERS")
            elif count == 8:
                replay_string = self.selection
                board_string += "█{:>25}{:<25}█\n".format(*replay_string)
            else:
                board_string += "█"
                for entry in row:
                    board_string += entry
                board_string += "█\n"
            count += 1
        os.system('cls')
        print(board_string)

    # печать меню пройгрыша
    def print_game_over(self):
        if self.lives == 0 and not self.bool_end_sound:
            self.bool_end_sound = True
        self.confirm_selection = False
        board_string = ""
        count = 0
        for row in self.game_grid:
            if count == 6:
                board_string += ":{:^50}:\n".format("Игра пройграна")
            elif count == 7:
                final_score = self.get_final_score()
                score_string = "Финальный счет : " + str(final_score)
                board_string += "█{:^50}█".format(score_string)
            elif count == 8:
                replay_string = self.selection
                board_string += "█{:>25}{:<25}█\n".format(*replay_string)
            else:
                board_string += "█"
                for entry in row:
                    board_string += entry
                board_string += "█\n"
            count += 1
        os.system('cls')
        print(board_string)

    # Возвращение игрока в стойло
    def is_playing(self):
        return self.lives > 0 and self.score < 300
    def get_final_score(self):
        return self.score + self.lives * 100

    # Сглаживает частоту кадров до чуть более 30 кадров в секунду
    def advance_frame(self):
        self.frame_count += 1
        delay = (1/30) - (time.perf_counter() - self.start)
        if delay < 0:
            delay = 0
        time.sleep(delay)
        self.start = time.perf_counter()
        self.bool_frame_sound = False
def main():

    # создание размеров
    os.system('mode con: cols=52 lines=20')

    # Дисплей пременные
    bool_loaded = True
    bool_started = False
    bool_quit = False

    # устанновка игровых данных
    game_vars = GameVariables()

    while not bool_quit:
        # Збрасывает игру
        if not bool_loaded:
            game_vars = GameVariables()
            bool_loaded = True

        # старт игрвого меню 
        if not bool_started:
            game_vars.enter_menu()
            game_vars.update_board()
            while game_vars.is_in_menu():
                game_vars.print_game_start()
                game_vars.get_keypress()
                if game_vars.is_selection_confirmed():
                    if game_vars.is_replay_selected():
                        bool_started = True
                        break
                    else:
                        bool_quit = True
                        game_vars.exit_menu()
                game_vars.advance_frame()

        # Игровой цикл
        if not bool_quit:
            while game_vars.is_playing():
                game_vars.get_keypress()
                game_vars.move_projectiles()
                game_vars.check_collisions()
                game_vars.move_enemies()
                game_vars.update_board()
                game_vars.print_board()
                game_vars.advance_frame()

            game_vars.enter_menu()
            while game_vars.is_in_menu():
                game_vars.print_game_over()
                game_vars.get_keypress()
                if game_vars.is_selection_confirmed():
                    if game_vars.is_replay_selected():
                        bool_loaded = False
                        del game_vars
                        break
                    else:
                        bool_quit = True
                        game_vars.exit_menu()
                game_vars.advance_frame()


main()

